/***************************************************************************
                          xmgr.h  -  description
                             -------------------
    begin                : Tue Feb 18 2003
    copyright            : (C) 2003 by Sheldon Lee Wen
    email                : leewsb@hotmail.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/** This is a temporary replacement of the XKB handling code until I can get
 *  the XKB handling code working properly. */
#ifndef XMGR_H
#define XMGR_H

/* settings from configure */
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

extern "C" {
#include <stdio.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xos.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Xproto.h>
}

#include <string>
#include <iostream>

#include <lineak/definitions.h>
#define MAXRETRIES 25 /* prevents possible race condition, don't set this too low!! 25 will do */

class LKbd;

/**Manager initializing and restoring X configurations.
  *@author Sheldon Lee Wen
  */

class Xmgr {
public: 
  Xmgr(string display = null);
  ~Xmgr();
  Display* getDisplay() { return ourdisplay; }
  bool initialized();
  bool initialize(LKbd& myKbd);
  void cleanup(LKbd& myKbd);

private:
  static int Xhandler(Display* theDisplay, XErrorEvent* xev);
	
  Display *ourdisplay;
  int screen;
  string displayname;
  unsigned long mask;

  static bool caughtXerror;
};

#endif
